<?php
/**
 * A Cool Debate Component
 * @link http://acoolsip.com
 * @Copyright Copyright (C) 2010- ... acoolsip.com
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );

/**
 * Hello Model
 *
 * @package    Joomla.Tutorials
 * @subpackage Components
 */
class ACoolDebateModelACoolDebate extends JModel
{
	/**
	 * Items total
	 * @var integer
	 */
	var $_total = null;
       
	/**
	 * Pagination object
	 * @var object
	 */
	var $_pagination = null;
	
	
	function __construct()
	{
	      parent::__construct();
       
	      global $mainframe, $option;
       
	      // Get pagination request variables
	      $limit = 5;//= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	      $limitstart = JRequest::getVar('limitstart', 0, '', 'int');
       
	      // In case limit has been changed, adjust it
	      $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
       
	      $this->setState('limit', $limit);
	      $this->setState('limitstart', $limitstart);
	}
  
	function getData()
	{
		/*$db =& JFactory::getDBO();

		$query = 'SELECT * FROM #__debate';
		$db->setQuery( $query );
		$data = $db->loadObjectList();

		return $data;*/

		// if data hasn't already been obtained, load it
		if (empty($this->_data))
		{
		 
		    $query = 'SELECT * FROM #__debate ORDER BY debate_id ASC';
		    $this->_data = $this->_getList($query, $this->getState('limitstart'), $this->getState('limit'));	
		}
		return $this->_data;
	}
	
	function getTotal()
	{
	      // Load the content if it doesn't already exist
	      if (empty($this->_total))
	      {
		
		  $query = 'SELECT debate_id FROM #__debate';
		  $this->_total = $this->_getListCount($query);
		  
	      }
	      return $this->_total;
	}
	
	function getPagination()
	{
	      // Load the content if it doesn't already exist
	      if (empty($this->_pagination)) {
		  jimport('joomla.html.pagination');
		  $this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
	      }	      
	      return $this->_pagination;
	}	
	
	function getAvatars($pro = null, $con = null)
	{
		if($pro == null)
		$pro = 0;
		if($con == null)
		$con = 0;
		
		$path = "";
		$db =& JFactory::getDBO();		
		
		//get config area and figure out which community component they're using.
		$params =& JComponentHelper::getParams( 'com_acooldebate' );
		$userCommunity = $params->get('com_field');
		
		switch($userCommunity)
		{
			case "com_comprofiler":
				$tableName = "#__comprofiler";
				$columnName = "avatar";
				$idColumn = "user_id";
				$path = "images".DS."comprofiler".DS;
				break;
			case "com_community":
				$jspath = JPATH_ROOT.DS.'components'.DS.'com_community';
				include_once($jspath.DS.'libraries'.DS.'core.php');
				 
				// Get CUser object
				$user =& CFactory::getUser($pro);
				$avatarUrl = $user->getThumbAvatar();
				$avatars['pro'] = $avatarUrl;
				
				$user =& CFactory::getUser($con);
				$avatarUrl = $user->getThumbAvatar();			
				$avatars['con'] = $avatarUrl;
				return $avatars;
				break;
			case "com_cbe":				
				$tableName = "#__cbe";
				$columnName = "avatar";
				$idColumn = "user_id";
				$path = "images".DS."cbe".DS;
				break;
			case "com_joomunity":
				$tableName = "#__joom_users";
				$columnName = "user_picture";
				$idColumn = "user_id";
				$path = "components/com_joomunity/files/avatars/";
				break;
			default:
				$avatars['pro'] = "components/com_acooldebate/assets/images/thumbs_up.png";			
				$avatars['con'] = "components/com_acooldebate/assets/images/thumbs_down.png";
				return $avatars;
				break;
		}
				
		$sql = "SELECT " . $columnName . " FROM " . $tableName . " WHERE " . $idColumn . " = " . $pro;
		$db->setQuery($sql);
		$av = $db->loadResult();
		if($av)
			$avatars['pro'] = $path . $av;	
		else
			$avatars['pro'] = "components/com_acooldebate/assets/images/thumbs_up.png";
			
		$sql = "SELECT " . $columnName . " FROM " . $tableName . " WHERE " . $idColumn . " = " . $con;
		$db->setQuery($sql);
		$av = $db->loadResult();
		if($av)
			$avatars['con'] = $path . $av;
		else
			$avatars['con'] = "components/com_acooldebate/assets/images/thumbs_down.png";		
		return $avatars;
	}
	
	function getVotingPeriod($votingPeriod = null)
	{
		$db =& JFactory::getDBO();
		$sql = "SELECT voting_period FROM #__debate_voting_periods WHERE voting_period_id = " . $votingPeriod;
		$db->setQuery($sql);
		return $db->loadResult();
	}
	
	function getDebateLength($debateLength = null)
	{
		$db =& JFactory::getDBO();
		$sql = "SELECT argument_amount FROM #__debate_argument_max WHERE argument_max_id = " . $debateLength;
		$db->setQuery($sql);
		return $db->loadResult();
	}
	
	function getOpeningArgument($debate_id = null)
	{
		$db =& JFactory::getDBO();
		$sql = "SELECT argument FROM #__debate_arguments WHERE debate_id = " . $debate_id . " ORDER BY round ASC";
		$db->setQuery($sql);
		return $db->loadResult();
	}
	
	function store($post = null)
	{
		
		//global $mainframe;
		//$post = JRequest::get('post');
		$newPost['argument'] = nl2br($post['argument']);
		$newPost['user_id'] =& JFactory::getUser()->id;
		$newPost['date_time'] = $post['date_time'];
		$newPost['debate_id'] = $post['debate_id'];
		$newPost['round'] = $post['round'];
		//$newPost['user_id'] = $post['user_id'];

		
		
		$row =& $this->getTable('acooldebate');
		
		$row->date_time = $post['date_time'];
		
		/*echo "<pre>";
		print_r($row);
		echo "</pre>";	*/		
	
		// Bind the form fields to the debate table
		if (!$row->bind($newPost)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Make sure the debate record is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError( $row->getErrorMsg() );
			return false;
		}
		
	
		
		$db =& JFactory::getDBO();
		$sql = "SELECT pro_id, con_id FROM #__debate WHERE debate_id = " . $row->debate_id;
		$db->setQuery($sql);
		$pro_con = $db->loadObject($sql);
		if($pro_con->pro_id == null)
		{
			$collumn = "pro_id";
		}
		else
		{
			$collumn = "con_id";
		}
		$sql = "UPDATE #__debate SET " . $collumn . " = " . $row->user_id . " WHERE debate_id = " . $row->debate_id;
		$db->setQuery($sql);
		$db->query();
		return true;
		/*
		echo "<pre>";
		print_r($post);
		echo "</pre>";
		*/
	}
}
