<?php
/**
 * A Cool Debate Component
 * @link http://acoolsip.com
 * @Copyright Copyright (C) 2010- ... acoolsip.com
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );

/**
 * Hello Model
 *
 * @package    Joomla.Tutorials
 * @subpackage Components
 */
class ACoolDebateModelACoolDebateDetail extends JModel
{
	/**
	 * Gets the greeting
	 * @return string The greeting to be displayed to the user
	 */
	function getData()
	{
		$db =& JFactory::getDBO();
		$debate_id = JRequest::getInt('did');
		$query = 'SELECT argument, time_to_argue, debate_ends, da.debate_id, da.date_time, user_id, round, argument, category_id, pro_id, con_id, topic, rounds, voting_period, #__debate_argument_max.argument_amount FROM #__debate_arguments' .
		' AS da JOIN #__debate' .
		' AS d ON da.debate_id = d.debate_id' .
		' JOIN #__debate_argument_max' .
		' ON d.argument_max = #__debate_argument_max.argument_max_id' .
		/*' JOIN #__debate_voting_periods' .
		' ON d.voting_period = #__debate_voting_periods.voting_period_id' . */
		' WHERE da.debate_id = ' . $debate_id . 
		' ORDER BY round, argument_id ASC';
		$db->setQuery( $query );
		$data = $db->loadObjectList();
		$this->setError($this->_db->getErrorMsg());

		return $data;
	}
	
	function getComments($id = 0)
	{
		$params =& JComponentHelper::getParams( 'com_acooldebate' );
		$userCommunity = $params->get('com_field');
		$db =& JFactory::getDBO();
		$query = "";
		switch($userCommunity)
		{
			case "com_comprofiler":
				$tableName = "#__comprofiler";
				$columnName = "avatar";
				$path = "images/comprofiler/";
				$query = "SELECT dc.comment_id, dc.user_id, dc.debate_id, dc.commenters_website, dc.comment, CONCAT('" . $path . "',comp." . $columnName . ") AS ava FROM #__debate_comments AS dc, " . $tableName . " AS comp WHERE debate_id = " . $id . " AND dc.user_id = comp.user_id ORDER BY comment_id ASC";				
				break;
			case "com_community":
				$jspath = JPATH_ROOT.DS.'components'.DS.'com_community';
				include_once($jspath.DS.'libraries'.DS.'core.php');
				 
				$user =& CFactory::getUser($id);
				$avatarUrl = $user->getThumbAvatar();
				$avatar = $avatarUrl;
				$query = "SELECT dc.comment_id, dc.user_id, dc.debate_id, dc.commenters_website, dc.comment, '" . $avatar . "' as ava FROM #__debate_comments AS dc WHERE debate_id = " . $id . " ORDER BY comment_id ASC";
				
				break;
			case "com_joomunity":
				$tableName = "#__joom_users";
				$columnName = "user_picture";
				$idColumn = "user_id";
				$path = "components/com_joomunity/files/avatars/";
				$query = "SELECT dc.comment_id, dc.user_id, dc.debate_id, dc.commenters_website, dc.comment, CONCAT('" . $path . "',comp." . $columnName . ") AS ava FROM #__debate_comments AS dc, " . $tableName . " AS comp WHERE debate_id = " . $id . " AND dc.user_id = comp." . $idColumn . " ORDER BY comment_id ASC";
				
				break;
			default:
				$avatar = "components/com_acooldebate/assets/images/thumbs_up.png";	
				$query = "SELECT dc.comment_id, dc.user_id, dc.debate_id, dc.commenters_website, dc.comment, '" . $avatar . "' as ava FROM #__debate_comments AS dc WHERE debate_id = " . $id . " ORDER BY comment_id ASC";
				//return $avatars;
				break;
		}		
		

		$db->setQuery($query);
		$data = $db->loadObjectList();
		$this->setError($db->getErrorMsg());
		return $data;		
	}
	
	function getVotePoints($id = 0)
	{
		$db =& JFactory::getDBO();
		$query = "SELECT SUM(pro_points) as pro_points , SUM(con_points) as con_points FROM #__debate_votes_results WHERE debate_id = " . $id;
		$db->setQuery($query);
		$data = $db->loadObjectList();
		$this->setError($db->getErrorMsg());
		return $data;		
	}
	
	function getVotes()
	{
		$db =& JFactory::getDBO();
		$query = "SELECT * FROM #__debate_vote_questions ORDER BY question_id ASC";
		$db->setQuery($query);
		$votes = $db->loadObjectList();
		$this->setError($this->_db->getErrorMsg());
		return $votes;
	}
	
	function hasVoted($x)
	{
		if(!isset($x))
			return "false";
		$db =& JFactory::getDBO();
		$user =& JFactory::getUser();
		$user_id = $user->id;
		$query = "SELECT voter_id FROM #__debate_votes_results WHERE voter_id = " . $user_id . " AND debate_id = " . $x;
		$db->setQuery($query);
		$res = $db->loadResult();
		//echo $res;
		//echo $query;
		echo $db->getErrorMsg();
		if($res)
		return "true";
		else
		return "false";
		//return "";
	}
	
	function getAvatars($pro = null, $con = null)
	{
		if($pro == null)
		$pro = 0;
		if($con == null)
		$con = 0;
		
		$path = "";
		$db =& JFactory::getDBO();		
		
		//get config area and figure out which community component they're using.
		$params =& JComponentHelper::getParams( 'com_acooldebate' );
		$userCommunity = $params->get('com_field');
		
		switch($userCommunity)
		{
			case "com_comprofiler":
				$tableName = "#__comprofiler";
				$columnName = "avatar";
				$idColumn = "user_id";
				$path = "images/comprofiler/";
				break;
			case "com_community":
				$jspath = JPATH_ROOT.DS.'components'.DS.'com_community';
				include_once($jspath.DS.'libraries'.DS.'core.php');
				 
				// Get CUser object
				$user =& CFactory::getUser($pro);
				$avatarUrl = $user->getThumbAvatar();
				$avatars['pro'] = $avatarUrl;
				
				$user =& CFactory::getUser($con);
				$avatarUrl = $user->getThumbAvatar();			
				$avatars['con'] = $avatarUrl;
				return $avatars;
				break;
			case "com_joomunity":
				$tableName = "#__joom_users";
				$columnName = "user_picture";
				$idColumn = "user_id";
				$path = "components/com_joomunity/files/avatars/";
				break;
			default:
				$avatars['pro'] = "components/com_acooldebate/assets/images/thumbs_up.png";			
				$avatars['con'] = "components/com_acooldebate/assets/images/thumbs_down.png";
				return $avatars;
				break;
		}
				
		$sql = "SELECT " . $columnName . " FROM " . $tableName . " WHERE " . $idColumn . " = " . $pro;
		$db->setQuery($sql);
		$av = $db->loadResult();
		if($av)
			$avatars['pro'] = $path . $av;	
		else
			$avatars['pro'] = "components/com_acooldebate/assets/images/thumbs_up.png";
			
		$sql = "SELECT " . $columnName . " FROM " . $tableName . " WHERE " . $idColumn . " = " . $con;
		$db->setQuery($sql);
		$av = $db->loadResult();
		if($av)
			$avatars['con'] = $path . $av;
		else
			$avatars['con'] = "components/com_acooldebate/assets/images/thumbs_down.png";		
		return $avatars;
	}
	
	function storeComment($newPost)
	{
		$post = array();
		//$post['comment_id'] = 0;
		$post['commenters_website'] = $newPost['comment_web'];
		$post['user_id'] =& JFactory::getUser()->id;//$newPost['comment_web'];
		$post['comment'] = nl2br($newPost['comment_com']);
		$post['debate_id'] = $newPost['comment_debate'];
		JTable::addIncludePath('components'.DS.'com_acooldebate'.DS.'tables');
		$row =& $this->getTable('acoolcomments');		
		//$row->date_time = $post['date_time'];
		
		/*echo "<pre>";
		print_r($row);
		echo "</pre>";	*/		
	
		// Bind the form fields to the debate table
		if (!$row->bind($post)) {
			$this->setError($this->_db->getErrorMsg());		
			return false;
		}

		// Make sure the debate record is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError( $this->_db->getErrorMsg() );
			return false;
		}
		return true;
	}
	


}
